#
# General definitions.
#

# System type.

ENV_SYSTEM = UNIX

# Installation directory.

#OSE_ROOT_DIRECTORY = /usr/local/ose
#OSE_RELEASE_DIRECTORY = tst

# Default and desired C++ compilers.

DEFAULTC++COMPILER = GNU2.7.2
C++COMPILERS = GNU2.7.2

# Default and desired compilation variants.

DEFAULTVARIANT = dbg
VARIANTS = dbg opt prf std

#
# Default library management definitions.
#

define DEFAULT_SYM_CLEANUP
endef

define DEFAULT_LIB_CLOSURE
endef

define DEFAULT_LIB_ARCHIVE
$(AR) rv @LIB@ @OBJECTS@
endef

define DEFAULT_LIB_EXTRACT
$(AR) xv @LIB@
endef

define DEFAULT_PIC_CLOSURE
endef

define DEFAULT_PIC_ARCHIVE
$(AR) rv @LIB@ @OBJECTS@
endef

define DEFAULT_PIC_EXTRACT
$(AR) xv @LIB@
endef

define DEFAULT_PIC_LIBRARY
$(LD) -G -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ $(PIC_LDLIBS) @LDLIBS@
endef

#
# Compiler definitions.
#

# GNU C++ 2.7.2.

ifeq "$(C++COMPILERENV)" ""

GNU2.7.2_VARIANTS = dbg opt prf std
GNU2.7.2_PIC_VARIANTS =

GNU2.7.2_ENV_OODBMS =

GNU2.7.2_OPT_LIBRARIES =

GNU2.7.2_C++ = /usr/local/bin/g++
GNU2.7.2_CC = /usr/local/bin/gcc
GNU2.7.2_LD = /usr/ccs/bin/ld
GNU2.7.2_AR = /usr/ccs/bin/ar

GNU2.7.2_CPPFLAGS =
GNU2.7.2_CFLAGS = -V 2.7.2 -pipe
GNU2.7.2_C++FLAGS = -V 2.7.2 -pipe
GNU2.7.2_LDFLAGS =
GNU2.7.2_LDLIBS = -lm

GNU2.7.2_PIC_CPPFLAGS =
GNU2.7.2_PIC_CFLAGS = -fpic
GNU2.7.2_PIC_C++FLAGS = -fpic
GNU2.7.2_PIC_LDFLAGS =
GNU2.7.2_PIC_LDLIBS =

GNU2.7.2_CPPFLAGS_dbg =
GNU2.7.2_CFLAGS_dbg = -g
GNU2.7.2_C++FLAGS_dbg = -g
GNU2.7.2_LDFLAGS_dbg =
GNU2.7.2_LDLIBS_dbg =

GNU2.7.2_CPPFLAGS_opt = -DNDEBUG
GNU2.7.2_CFLAGS_opt = -O
GNU2.7.2_C++FLAGS_opt = -O
GNU2.7.2_LDFLAGS_opt =
GNU2.7.2_LDLIBS_opt =

GNU2.7.2_CPPFLAGS_prf =
GNU2.7.2_CFLAGS_prf = -pg
GNU2.7.2_C++FLAGS_prf = -pg
GNU2.7.2_LDFLAGS_prf =
GNU2.7.2_LDLIBS_prf =

GNU2.7.2_CPPFLAGS_std =
GNU2.7.2_CFLAGS_std =
GNU2.7.2_C++FLAGS_std =
GNU2.7.2_LDFLAGS_std =
GNU2.7.2_LDLIBS_std =

define GNU2.7.2_PIC_LIBRARY
$(C++) -shared -h lib$(LIBRARY)$(SHLEXT).$(LIBVERSION) -o @LIB@ \
 $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ $(PIC_LDLIBS) @LDLIBS@
endef

endif

# SUN C++ 4.0.1.

ifeq "$(C++COMPILERENV)" ""

SUN4.0.1_VARIANTS = dbg opt prf std
SUN4.0.1_PIC_VARIANTS = opt std

SUN4.0.1_ENV_OODBMS =

SUN4.0.1_OPT_LIBRARIES =

SUN4.0.1_C++ = /opt/SUNWspro/SC3.0.1/bin/CC
SUN4.0.1_CC = /opt/SUNWspro/SC3.0.1/bin/cc
SUN4.0.1_LD = /usr/ccs/bin/ld
SUN4.0.1_LD = /usr/ccs/bin/ar

SUN4.0.1_CPPFLAGS =
SUN4.0.1_CFLAGS =
SUN4.0.1_C++FLAGS = +p
SUN4.0.1_LDFLAGS =
SUN4.0.1_LDLIBS =

SUN4.0.1_PIC_CPPFLAGS =
SUN4.0.1_PIC_CFLAGS = -K pic
SUN4.0.1_PIC_C++FLAGS = -kpic
SUN4.0.1_PIC_LDFLAGS =
SUN4.0.1_PIC_LDLIBS =

SUN4.0.1_CPPFLAGS_dbg =
SUN4.0.1_CFLAGS_dbg = -g
SUN4.0.1_C++FLAGS_dbg = -g
SUN4.0.1_LDFLAGS_dbg =
SUN4.0.1_LDLIBS_dbg =

SUN4.0.1_CPPFLAGS_opt = -DNDEBUG
SUN4.0.1_CFLAGS_opt = -O
SUN4.0.1_C++FLAGS_opt = -O
SUN4.0.1_LDFLAGS_opt =
SUN4.0.1_LDLIBS_opt =

SUN4.0.1_CPPFLAGS_prf =
SUN4.0.1_CFLAGS_prf = -pg
SUN4.0.1_C++FLAGS_prf = -pg
SUN4.0.1_LDFLAGS_prf =
SUN4.0.1_LDLIBS_prf =

SUN4.0.1_CPPFLAGS_std =
SUN4.0.1_CFLAGS_std =
SUN4.0.1_C++FLAGS_std =
SUN4.0.1_LDFLAGS_std =
SUN4.0.1_LDLIBS_std =

define SUN4.0.1_LIB_ARCHIVE
$(C++) -xar @PTRFLAGS@ -o @LIB@ @OBJECTS@
endef

define SUN4.0.1_PIC_LIBRARY
$(C++) -G @PIC_PTRFLAGS@ -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ \
 $(PIC_LDLIBS) @LDLIBS@
endef

endif

ifeq "$(C++COMPILERENV)" "THREAD"

SUN4.0.1_VARIANTS = dbg opt std
SUN4.0.1_PIC_VARIANTS = opt std

SUN4.0.1_ENV_OODBMS =

SUN4.0.1_OPT_LIBRARIES =

SUN4.0.1_C++ = /opt/SUNWspro/SC3.0.1/bin/CC
SUN4.0.1_CC = /opt/SUNWspro/SC3.0.1/bin/cc
SUN4.0.1_LD = /usr/ccs/bin/ld
SUN4.0.1_AR = /usr/ccs/bin/ar

SUN4.0.1_CPPFLAGS = -DHAVE_SOLARIS_THREADS -D_REENTRANT
SUN4.0.1_CFLAGS =
SUN4.0.1_C++FLAGS = -mt
SUN4.0.1_LDFLAGS =
SUN4.0.1_LDLIBS = -lthread

SUN4.0.1_PIC_CPPFLAGS =
SUN4.0.1_PIC_CFLAGS = -K pic
SUN4.0.1_PIC_C++FLAGS = -kpic
SUN4.0.1_PIC_LDFLAGS =
SUN4.0.1_PIC_LDLIBS =

SUN4.0.1_CPPFLAGS_dbg =
SUN4.0.1_CFLAGS_dbg = -g
SUN4.0.1_C++FLAGS_dbg = -g
SUN4.0.1_LDFLAGS_dbg =
SUN4.0.1_LDLIBS_dbg =

SUN4.0.1_CPPFLAGS_opt = -DNDEBUG
SUN4.0.1_CFLAGS_opt = -O
SUN4.0.1_C++FLAGS_opt = -O
SUN4.0.1_LDFLAGS_opt =
SUN4.0.1_LDLIBS_opt =

SUN4.0.1_CPPFLAGS_prf =
SUN4.0.1_CFLAGS_prf = -pg
SUN4.0.1_C++FLAGS_prf = -pg
SUN4.0.1_LDFLAGS_prf =
SUN4.0.1_LDLIBS_prf =

SUN4.0.1_CPPFLAGS_std =
SUN4.0.1_CFLAGS_std =
SUN4.0.1_C++FLAGS_std =
SUN4.0.1_LDFLAGS_std =
SUN4.0.1_LDLIBS_std =

define SUN4.0.1_LIB_ARCHIVE
$(C++) -xar @PTRFLAGS@ -o @LIB@ @OBJECTS@
endef

define SUN4.0.1_PIC_LIBRARY
$(C++) -G @PIC_PTRFLAGS@ -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ \
 $(PIC_LDLIBS) @LDLIBS@
endef

endif

ifeq "$(C++COMPILERENV)" "PTHREAD"

# SUN C++ 4.1.

ifeq "$(C++COMPILERENV)" ""

SUN4.1_VARIANTS = dbg opt prf std
SUN4.1_PIC_VARIANTS = opt std

SUN4.1_ENV_OODBMS =

SUN4.1_OPT_LIBRARIES =

SUN4.1_C++ = /opt/SUNWspro/SC4.0/bin/CC
SUN4.1_CC = /opt/SUNWspro/SC4.0/bin/cc
SUN4.1_LD = /usr/ccs/bin/ld
SUN4.1_AR = /usr/ccs/bin/ar

SUN4.1_CPPFLAGS =
SUN4.1_CFLAGS =
SUN4.1_C++FLAGS = +p
SUN4.1_LDFLAGS =
SUN4.1_LDLIBS =

SUN4.1_PIC_CPPFLAGS =
SUN4.1_PIC_CFLAGS = -K pic
SUN4.1_PIC_C++FLAGS = -kpic
SUN4.1_PIC_LDFLAGS =
SUN4.1_PIC_LDLIBS =

SUN4.1_CPPFLAGS_dbg =
SUN4.1_CFLAGS_dbg = -g
SUN4.1_C++FLAGS_dbg = -g
SUN4.1_LDFLAGS_dbg =
SUN4.1_LDLIBS_dbg =

SUN4.1_CPPFLAGS_opt = -DNDEBUG
SUN4.1_CFLAGS_opt = -O
SUN4.1_C++FLAGS_opt = -O
SUN4.1_LDFLAGS_opt =
SUN4.1_LDLIBS_opt =

SUN4.1_CPPFLAGS_prf =
SUN4.1_CFLAGS_prf = -pg
SUN4.1_C++FLAGS_prf = -pg
SUN4.1_LDFLAGS_prf =
SUN4.1_LDLIBS_prf =

SUN4.1_CPPFLAGS_std =
SUN4.1_CFLAGS_std =
SUN4.1_C++FLAGS_std =
SUN4.1_LDFLAGS_std =
SUN4.1_LDLIBS_std =

define SUN4.1_LIB_ARCHIVE
$(C++) -xar @PTRFLAGS@ -o @LIB@ @OBJECTS@
endef

define SUN4.1_PIC_LIBRARY
$(C++) -G @PIC_PTRFLAGS@ -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ \
 $(PIC_LDLIBS) @LDLIBS@
endef

endif

ifeq "$(C++COMPILERENV)" "THREAD"

SUN4.1_VARIANTS = dbg opt std
SUN4.1_PIC_VARIANTS = opt std

SUN4.1_ENV_OODBMS =

SUN4.1_OPT_LIBRARIES =

SUN4.1_C++ = /opt/SUNWspro/SC4.0/bin/CC
SUN4.1_CC = /opt/SUNWspro/SC4.0/bin/cc
SUN4.1_LD = /usr/ccs/bin/ld
SUN4.1_AR = /usr/ccs/bin/ar

SUN4.1_CPPFLAGS = -DHAVE_SOLARIS_THREADS -D_REENTRANT
SUN4.1_CFLAGS =
SUN4.1_C++FLAGS = -mt
SUN4.1_LDFLAGS =
SUN4.1_LDLIBS = -lthread

SUN4.1_PIC_CPPFLAGS =
SUN4.1_PIC_CFLAGS = -K pic
SUN4.1_PIC_C++FLAGS = -kpic
SUN4.1_PIC_LDFLAGS =
SUN4.1_PIC_LDLIBS =

SUN4.1_CPPFLAGS_dbg =
SUN4.1_CFLAGS_dbg = -g
SUN4.1_C++FLAGS_dbg = -g
SUN4.1_LDFLAGS_dbg =
SUN4.1_LDLIBS_dbg =

SUN4.1_CPPFLAGS_opt = -DNDEBUG
SUN4.1_CFLAGS_opt = -O
SUN4.1_C++FLAGS_opt = -O
SUN4.1_LDFLAGS_opt =
SUN4.1_LDLIBS_opt =

SUN4.1_CPPFLAGS_prf =
SUN4.1_CFLAGS_prf = -pg
SUN4.1_C++FLAGS_prf = -pg
SUN4.1_LDFLAGS_prf =
SUN4.1_LDLIBS_prf =

SUN4.1_CPPFLAGS_std =
SUN4.1_CFLAGS_std =
SUN4.1_C++FLAGS_std =
SUN4.1_LDFLAGS_std =
SUN4.1_LDLIBS_std =

define SUN4.1_LIB_ARCHIVE
$(C++) -xar @PTRFLAGS@ -o @LIB@ @OBJECTS@
endef

define SUN4.1_PIC_LIBRARY
$(C++) -G @PIC_PTRFLAGS@ -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ \
 $(PIC_LDLIBS) @LDLIBS@
endef

endif

ifeq "$(C++COMPILERENV)" "PTHREAD"

SUN4.1_VARIANTS = dbg opt std
SUN4.1_PIC_VARIANTS = opt std

SUN4.1_ENV_OODBMS =

SUN4.1_OPT_LIBRARIES =

SUN4.1_C++ = /opt/SUNWspro/SC4.0/bin/CC
SUN4.1_CC = /opt/SUNWspro/SC4.0/bin/cc
SUN4.1_LD = /usr/ccs/bin/ld
SUN4.1_AR = /usr/ccs/bin/ar

SUN4.1_CPPFLAGS = -DHAVE_POSIX_THREADS -D_REENTRANT
SUN4.1_CFLAGS =
SUN4.1_C++FLAGS = -mt
SUN4.1_LDFLAGS =
SUN4.1_LDLIBS = -lpthread

SUN4.1_PIC_CPPFLAGS =
SUN4.1_PIC_CFLAGS = -K pic
SUN4.1_PIC_C++FLAGS = -kpic
SUN4.1_PIC_LDFLAGS =
SUN4.1_PIC_LDLIBS =

SUN4.1_CPPFLAGS_dbg =
SUN4.1_CFLAGS_dbg = -g
SUN4.1_C++FLAGS_dbg = -g
SUN4.1_LDFLAGS_dbg =
SUN4.1_LDLIBS_dbg =

SUN4.1_CPPFLAGS_opt = -DNDEBUG
SUN4.1_CFLAGS_opt = -O
SUN4.1_C++FLAGS_opt = -O
SUN4.1_LDFLAGS_opt =
SUN4.1_LDLIBS_opt =

SUN4.1_CPPFLAGS_prf =
SUN4.1_CFLAGS_prf = -pg
SUN4.1_C++FLAGS_prf = -pg
SUN4.1_LDFLAGS_prf =
SUN4.1_LDLIBS_prf =

SUN4.1_CPPFLAGS_std =
SUN4.1_CFLAGS_std =
SUN4.1_C++FLAGS_std =
SUN4.1_LDFLAGS_std =
SUN4.1_LDLIBS_std =

define SUN4.1_LIB_ARCHIVE
$(C++) -xar @PTRFLAGS@ -o @LIB@ @OBJECTS@
endef

define SUN4.1_PIC_LIBRARY
$(C++) -G @PIC_PTRFLAGS@ -o @LIB@ $(PIC_LDFLAGS) @LDFLAGS@ @OBJECTS@ \
 $(PIC_LDLIBS) @LDLIBS@
endef

endif
