#ifndef OTC_PYTHON_PYAGENT_HH
#define OTC_PYTHON_PYAGENT_HH
/*
// ============================================================================
//
// = LIBRARY
//     OTC
// 
// = FILENAME
//     python/pyagent.hh
//
// = AUTHOR(S)
//     Graham Dumpleton
// 
// = COPYRIGHT
//     Copyright 1999-2001 DUMPLETON SOFTWARE CONSULTING PTY LIMITED
//
// ============================================================================
*/

#include <Python.h>

#include <OTC/dispatch/evagent.hh>

/* ------------------------------------------------------------------------- */

class OSE_EXPORT OTC_PyAgent : public PyObject, public OTC_EVAgent
{
  public:

  			OTC_PyAgent(PyObject* theOuter);

    static PyObject*	create(PyObject* theModule, PyObject* theArgs);

    PyObject*		obj_getattr(char const* theName);

    static void         sys_dealloc(PyObject*);

    static PyObject*    sys_getattr(PyObject*, char*);

    static PyObject*	mfn_id(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_startTimer(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_cancelTimer(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_cancelAllTimers(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_setAlarm(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_cancelAlarm(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_cancelAllAlarms(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_scheduleAction(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_scheduleCronAction(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_cancelAction(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_cancelAllActions(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_subscribeSignal(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_unsubscribeSignal(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_unsubscribeAllSignals(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_scheduleShutdown(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_suspendShutdown(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_resumeShutdown(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_subscribeShutdown(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_unsubscribeShutdown(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_subscribeSocket(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_unsubscribeSocket(PyObject*, PyObject* theArgs);

    static PyObject*	mfn_unsubscribeAllSockets(PyObject*, PyObject* theArgs);

  protected:

    void		handle(OTC_Event* theEvent);

  protected:

			~OTC_PyAgent();

    PyObject*		outer_;

  private:

			OTC_PyAgent(OTC_PyAgent const&);

    OTC_PyAgent&	operator=(OTC_PyAgent const&);

    static PyTypeObject gType_;

    static PyMethodDef	gMethods_[];
};

/* ------------------------------------------------------------------------- */

#endif /* OTC_PYTHON_PYAGENT_HH */
