/*
// ============================================================================
//
// = LIBRARY
//     OTC
// 
// = FILENAME
//     text/otcstrngbuf.cc
//
// = AUTHOR(S)
//     Graham Dumpleton
// 
// = COPYRIGHT
//     Copyright 2000-2001 DUMPLETON SOFTWARE CONSULTING PTY LIMITED
//
// ============================================================================
*/

#ifdef __GNUG__
#pragma implementation "OTC/text/strngbuf.hh"
#endif

#include <OTC/text/strngbuf.hh>

#ifndef zapeof
#define zapeof(c) ((c)&0377)
#endif

#if defined(ENV_OSTORE) && defined(CXX_DEC) && defined(__alpha)
#pragma __environment save
#pragma __environment header_defaults
#endif

/* ------------------------------------------------------------------------- */
OTC_StringBuf::~OTC_StringBuf()
{
  // Nothing to do.
}

/* ------------------------------------------------------------------------- */
OTC_StringBuf::OTC_StringBuf(OTC_String& theString)
  : string_(theString)
{
  // Nothing to do.
}

/* ------------------------------------------------------------------------- */
#if defined(ENV_CXXSTDLIB)
OTC_StringBuf::int_type OTC_StringBuf::overflow(int_type c)
#else
int OTC_StringBuf::overflow(int c)
#endif
{
#if defined(ENV_CXXSTDLIB)
  if (traits_type::eq_int_type(c,traits_type::eof()))
    return traits_type::eof();
#else
  if (c == EOF)
    return EOF;
#endif

  string_.append(char(c));

#if defined(ENV_CXXSTDLIB)
  return traits_type::not_eof(c);
#else
  return zapeof(c);
#endif
}

/* ------------------------------------------------------------------------- */
#if defined(ENV_CXXSTDLIB)
OTC_StringBuf::int_type OTC_StringBuf::underflow()
#else
int OTC_StringBuf::underflow()
#endif
{
  return 0;
}

#if defined(ENV_OSTORE) && defined(CXX_DEC) && defined(__alpha)
#pragma __environment restore
#endif

/* ------------------------------------------------------------------------- */
